//////////////////////////////////////////////////////////////////
// This is a loader for Skype which allows its usage with softice
// v2 : look 'n replace done
// tested with 
//////////////////////////////////////////////////////////////////

/* JUST FOR REFERENCE :
                 ; ASCII "Starting  .."


2.0.0.90 :

00E54610   74 1A            JE SHORT Skype.00E5462C
00E54612   6A 00            PUSH 0
00E54614   68 E449E500      PUSH Skype.00E549E4                      ; ASCII "Skype"
00E54619   68 EC49E500      PUSH Skype.00E549EC                     ; ASCII "Skype is not compatible with system debuggers like SoftICE."
00E5461E   6A 00            PUSH 0
00E54620   E8 834A5BFF      CALL <JMP.&user32.MessageBoxA>
00E54625   6A 00            PUSH 0
00E54627   E8 834A5BFF      CALL <JMP.&kernel32.ExitProcess>
00E5462C   E8 xxxxxxxx      CALL Skype.00E2BOCO                 ; ASCII "Starting  .."


search for :
74 1A 6A 00 68 ?? ?? ?? ?? 68 ?? ?? ?? ?? 6A 00 E8 ?? ?? ?? ?? 6A 00 E8 ?? ?? ?? ??
replace with :
EB ...
*/

#include <windows.h>
#include <stdio.h>

#define ERRORMSG(a) MessageBox(NULL, a, "Error", MB_ICONERROR|MB_OK);
#define BUFLEN 65535

TCHAR searchData[30] = "\x74\x1A\x6A\x00\x68\xCC\xCC\xCC\xCC\x68\xCC\xCC\xCC\xCC\x6A\x00\xE8\xCC\xCC\xCC\xCC\x6A\x00\xE8\xCC\xCC\xCC\xCC";
SIZE_T searchDataLen = 28;
TCHAR wildcardByte = 0xCC; /* yeah, damn ugly, but who cares ? it works =) laziness is everything... */
TCHAR readBuffer[BUFLEN];
SIZE_T readLen;

int searchAndDestroy(void);

int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	OFSTRUCT ofs;
	TCHAR buf[MAX_PATH] = "";
	TCHAR newByte = 0xEB;
	TCHAR origByte = 0x74;
	SIZE_T searchOffset = 0xA00000;
	SIZE_T searchOffsetStop = 0xF00000;
	SIZE_T patchOffset;

	(void)hinst;
	(void)hinstPrev;
	(void)lpCmdLine;
	(void)nCmdShow;
	
	GetModuleFileName(NULL, buf, MAX_PATH);
	buf[(strrchr(buf, '\\') - buf) + 1] = '\0';
	strcat(buf, "skype.exe");

	fprintf(stderr, "OpenFile... ");
	if (OpenFile(buf, &ofs, OF_EXIST) == HFILE_ERROR)
	{
		ERRORMSG("Skype.exe not found in current directory...exiting!")
		return 1;
	}
	fprintf(stderr, "OK\n");

	fprintf(stderr, "GetStartupInfo... ");
	GetStartupInfo(&si);
	fprintf(stderr, "OK\n");

	fprintf(stderr, "CreateProcess... ");
	printf("CreateProcess...\n");
	if (!CreateProcess((LPCSTR)buf,
		0,
		NULL,
		NULL,
		FALSE,
		CREATE_SUSPENDED,
		NULL,
		NULL,
		&si,
		&pi))
	{
		ERRORMSG("CreateProcess error...exiting!");
		return 1;
	}
	fprintf(stderr, "OK\n");
	
	while (searchOffset < searchOffsetStop) {
		fprintf(stderr, "ReadProcessMemory @ 0x%lx... ", searchOffset);
		if (!ReadProcessMemory(pi.hProcess, (LPCVOID)searchOffset, readBuffer, BUFLEN, &readLen))
		{
			ERRORMSG("ReadProcessMemory error...exiting!");
			return 1;
		}
		fprintf(stderr, "OK\n");
		fprintf(stderr, "Looking for data to patch... ");
		if ((patchOffset = searchAndDestroy()) < BUFLEN) {
			patchOffset += searchOffset - searchDataLen;
			fprintf(stderr, "FOUND at offset 0x%lx !\n", patchOffset);
			break;
		}
		else {
			fprintf(stderr, "not found\n");
		}
		searchOffset += BUFLEN - searchDataLen;
		patchOffset = 0;
	}
	
	if (!patchOffset) {
		ERRORMSG("Can't find patch offset, this is probably a too new version of Skype, sorry !");
		return 1;
	}

	fprintf(stderr, "WriteProcessMemory... ");
	if (!WriteProcessMemory(pi.hProcess, (LPVOID)patchOffset, &newByte, 1, NULL))
	{
		ERRORMSG("WriteProcessMemory error of newByte...exiting!");
		return 1;
	}
	fprintf(stderr, "OK\n");
	
	fprintf(stderr, "ResumeThread... ");
	if (!ResumeThread(pi.hThread))
	{
		ERRORMSG("ResumeThread error...exiting!");
	}
	fprintf(stderr, "OK\n");
	
	fprintf(stderr, "WaitForInputIdle... ");
	if (WaitForInputIdle(pi.hProcess, INFINITE))
	{
		ERRORMSG("WaitForInputIdle error...exiting!");
	}
	fprintf(stderr, "OK\n");
	
	fprintf(stderr, "WriteProcessMemory... ");
	if (!WriteProcessMemory(pi.hProcess, (LPVOID)patchOffset, &origByte, 1, NULL))
	{
		ERRORMSG("WriteProcessMemory error of origByte...exiting!");
	}
	fprintf(stderr, "OK\n");
	
	return 0;
}

int searchAndDestroy(void) {
	SIZE_T offset;
	SIZE_T searchOffset;

	for (offset = 0, searchOffset = 0; (offset < readLen) && (searchOffset < searchDataLen); offset++) {
		if ((readBuffer[offset] == searchData[searchOffset]) || (searchData[searchOffset] == wildcardByte)) { searchOffset++; }
		else { searchOffset = 0; }
	}

	return offset;
}

// EOF
